#include <icpack/load>
#include <zombiereloaded>
#define PVERSION "2.0"
#define ATTACHMENT "forward"
new bool:glow[MAXLUDES+1] = {false,...}
new glowentity[MAXLUDES+1] = {-1,...}
new Handle:gH_Enabled = INVALID_HANDLE;
new Handle:gH_Return = INVALID_HANDLE;
new Handle:gH_NVRadius = INVALID_HANDLE;
new Handle:gH_NVEnable = INVALID_HANDLE;
new Handle:gH_NVLight = INVALID_HANDLE;
new Handle:gH_NVReturn = INVALID_HANDLE;

new bool:bEnabled = true;
new bool:bRtn = false;
new bool:bNVLight = true;
new bool:bNVEnabled = true;
new Float:flNVRad = 350.0;
new bool:bNVRtn = false;

public Plugin:myinfo =
{
	name = "[ZR] Flashlight & NightVision",
	author = "Mitch (+inklesspen)",
	description = "Replaces +lookatweapon with a toggleable flashlight. Also adds the command: sm_flashlight",
	version = PVERSION,
	url = "https://forums.alliedmods.net/showthread.php?t=227224"
};

stock FakePrecacheSound( const String:szPath[] )
{
	AddToStringTable( FindStringTable( "soundprecache" ), szPath );
}

public OnPluginStart()
{
	gH_Enabled 		= CreateConVar("sm_flashlight_enabled", "1", 
					"0 = Disables flashlight; 1 = Enables flashlight", 		FCVAR_PLUGIN, true, 0.0, true, 1.0);
	gH_Return 	= CreateConVar("sm_flashlight_return", "0", 
					"0 = Doesn't return blocking +look at weapon; 1 = Does return", FCVAR_PLUGIN, true, 0.0, true, 1.0);
	gH_NVRadius 	= CreateConVar("sm_lightvision_radius", "350.0", 
					"NV Lighting radius (if enabled \"sm_lightvision_enable\")", FCVAR_PLUGIN, true, 0.0, false);
	gH_NVLight 	= CreateConVar("sm_lightvision_enable", "0", 
					"Zombie with lighting (vision only for owner)", FCVAR_PLUGIN, true, 0.0, true, 1.0);
	gH_NVEnable 	= CreateConVar("sm_nightvision_enable", "0", 
					"Enable NightVision", FCVAR_PLUGIN, true, 0.0, true, 1.0);
	gH_NVReturn 	= CreateConVar("sm_nightvision_return", "0", 
					"0 = Doesn't return blocking +look at weapon; 1 = Does return", FCVAR_PLUGIN, true, 0.0, true, 1.0);
	HookConVarChange(gH_Enabled, ConVarChanged);
	HookConVarChange(gH_Return, ConVarChanged);
	HookConVarChange(gH_NVRadius, ConVarChanged);
	HookConVarChange(gH_NVLight, ConVarChanged);
	HookConVarChange(gH_NVEnable, ConVarChanged);
	HookConVarChange(gH_NVReturn, ConVarChanged);
	AutoExecConfig(true, "zr_flashlight", "sourcemod/zombiereloaded");

	CreateConVar("sm_flashlight_version", PVERSION, "CsGoFlashlight Version", FCVAR_DONTRECORD|FCVAR_NOTIFY);
	HookEvent("player_death", Event_Death)
	AddCommandListener(Command_LAW, "+lookatweapon");	//Hooks cs:go's flashlight replacement 'look at weapon'.
	RegConsoleCmd("sm_myflash", Command_MYFlash); 	//Bindable Flashlight command
	for(new i=1;i<=64;i++)
	{
		OnClientPutInServer2(i)
	}
}

public Event_Death(Handle event, char[] name, bool:dbc)
{
	int client = GetClientOfUserId(GetEventInt(event, "userid"))
	SpawnPost(client)
}

public OnMapStart()
{
	FakePrecacheSound("*/ic/zrlv/flashlight.mp3")
	AddFileToDownloadsTable("sound/ic/zrlv/flashlight.mp3")
}

public ConVarChanged(Handle:cvar, const String:oldVal[], const String:newVal[])
{
	if(cvar == gH_Enabled)
		bEnabled = bool:StringToInt(newVal);
	if(cvar == gH_Return)
		bRtn = bool:StringToInt(newVal);
	if(cvar == gH_NVReturn)
		bNVRtn = bool:StringToInt(newVal);
	if(cvar == gH_NVRadius)
		flNVRad = StringToFloat(newVal);
	if(cvar == gH_NVEnable)
		bNVEnabled = bool:StringToInt(newVal);
	if(cvar == gH_NVLight)
		bNVLight = bool:StringToInt(newVal);
}
/*
new bool:bEnabled = true;
new bool:bLAW = true;
new bool:bRtn = false;
new bool:bNVLight = true;
new bool:bNVEnabled = true;
new bool:iNVRad = 600;
new bool:bNVRtn = false;
new bool:bNVLAW = false;
*/

public Action Command_MYFlash(client, args)
{
	PrintToChat(client, "1: %i", GetEntProp(client, Prop_Send, "m_fEffects") ^ 4);
	PrintToChat(client, "2: %i", GetEntProp(client, Prop_Send, "m_fEffects"));
}

public Action:ZR_OnClientInfect(&client, &attacker, &bool:motherInfect, &bool:respawnOverride, &bool:respawn)
{
	if(GetEntProp(client, Prop_Send, "m_fEffects") == 4)
		SetEntProp(client, Prop_Send, "m_fEffects", GetEntProp(client, Prop_Send, "m_fEffects") ^ 4)
}

public ZR_OnClientHumanPost(client, bool:respawn, bool:protect)
{
	RemoveLight(client)
}

public OnEntityDestroyed(entity)
{
	if(entity>64&&entity<2049)
		SDKUnhook(entity, SDKHook_SetTransmit, SetTransmit)
	for(new i=1;i<=64;i++)
	{
		if(glowentity[i]==entity)
			RemoveLight(i)
	}
}

public Action SetTransmit(int entity, int client)
{
	if(!YesPlayer(client))
		return Plugin_Continue
	if(!YesEntityMe(entity))
		return Plugin_Continue
	if(glowentity[client]!=entity)
		return Plugin_Handled
	return Plugin_Continue
}

stock SetParentEx(iParent, iChild) 
{ 
    SetVariantString("!activator"); 
    AcceptEntityInput(iChild, "SetParent", iParent, iChild); 
} 

public Action:Command_LAW(client, const String:command[], argc)
{
	if(!IsPlayerAlive(client))
		return Plugin_Continue;
	if(ZR_IsClientHuman(client))
	{
		if(!bEnabled) //Enable this hook?
			return Plugin_Continue;

		if(!IsClientInGame(client)) //If player is not in-game then ignore!
			return Plugin_Continue;
		
		float poss[3]
		GetClientEyePosition(client, poss)
		EmitAmbientSound("*/ic/zrlv/flashlight.mp3", poss, client);
		SetEntProp(client, Prop_Send, "m_fEffects", GetEntProp(client, Prop_Send, "m_fEffects") ^ 4); 
		//Bacardi suggested this instead of adding a new variable.
		return (bRtn) ? Plugin_Continue : Plugin_Handled;
	}
	else
	{
		if(!IsClientInGame(client))
			return Plugin_Continue;
			
		if(bNVEnabled)
		{
			(GetEntProp(client, Prop_Send, "m_bNightVisionOn") == 0) ? SetEntProp(client, Prop_Send, "m_bNightVisionOn", 1) : SetEntProp(client, Prop_Send, "m_bNightVisionOn", 0)
		}
		if(bNVLight)
		{
			glow[client] ? RemoveLight(client) : SetLight(client)
		}
		return (bNVRtn) ? Plugin_Continue : Plugin_Handled;
	}
}

public RemoveLight(client)
{
	if(!(client<65&&client>0))
		return;
	if(YesEntityMe(glowentity[client]))
		AcceptEntityInput(glowentity[client], "kill")
	glow[client]=false
	glowentity[client]=-1
}

public SetLight(client)
{
	new iEntity = CreateEntityByName("light_dynamic");
	glowentity[client]=iEntity
	glow[client]=true
	SDKHook(iEntity, SDKHook_SetTransmit, SetTransmit)
	DispatchKeyValue(iEntity, "inner_cone", "0");
	DispatchKeyValue(iEntity, "cone", "80");
	DispatchKeyValue(iEntity, "brightness", "1");
	DispatchKeyValueFloat(iEntity, "spotlight_radius", 90.0);
	DispatchKeyValue(iEntity, "pitch", "90");
	DispatchKeyValue(iEntity, "style", "1");
	DispatchKeyValue(iEntity, "_light", "128 255 128 40");
	DispatchKeyValueFloat(iEntity, "distance", flNVRad);
	DispatchSpawn(iEntity);
//	SetParentEx(client, iEntity)
	new Float:pos[3]
	GetClientAbsOrigin(client, pos)
	TeleportEntity(iEntity, pos, NULL_VECTOR, NULL_VECTOR)
	SetEntityMoveType(iEntity, MOVETYPE_NONE)
	SetParentEx(client, iEntity)
	SetVariantString(ATTACHMENT);
	AcceptEntityInput(iEntity, "SetParentAttachment", iEntity, iEntity, 0);
}

public OnClientPutInServer2(client)
{
	glow[client]=false
	glowentity[client]=-1
}

public OnClientPutInServer(client)
{
	SDKHook(client, SDKHook_SpawnPost, SpawnPost);
	OnClientPutInServer2(client)
}

public SpawnPost(client)
{
	SetEntProp(client, Prop_Send, "m_bNightVisionOn", 0);
	RemoveLight(client)
}